Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 4742)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 4792)
@@ -339,42 +333,36 @@
     CHARACTER (LEN=7), DIMENSION(max_masks,0:1,100) ::  domask_unit
 
+    INTEGER(iwp), DIMENSION(1:max_masks,0:1) ::  id_dim_time_mask, id_dim_x_mask, id_dim_xu_mask,  &
+                                                 id_dim_y_mask, id_dim_yv_mask, id_dim_zs_mask,    &
+                                                 id_dim_zu_mask, id_dim_zw_mask,                   &
+                                                 id_set_mask,                                      &
+                                                 id_var_time_mask, id_var_x_mask, id_var_xu_mask,  &
+                                                 id_var_y_mask, id_var_yv_mask, id_var_zs_mask,    &
+                                                 id_var_zu_mask, id_var_zw_mask,                   &
+                                                 id_var_zusi_mask, id_var_zwwi_mask
+
+
+    INTEGER(iwp), DIMENSION(1:max_masks,0:1,100) ::  id_var_domask
+    INTEGER(iwp), DIMENSION(0:2,1:max_masks,0:1) ::  id_var_eutm_mask, id_var_nutm_mask
+    INTEGER(iwp), DIMENSION(0:2,1:max_masks,0:1) ::  id_var_lat_mask, id_var_lon_mask
+
+
     LOGICAL ::  output_for_t0 = .FALSE.
 
-    INTEGER(iwp), DIMENSION(1:max_masks,0:1) ::  id_dim_time_mask, id_dim_x_mask, &
-                   id_dim_xu_mask, id_dim_y_mask, id_dim_yv_mask, id_dim_zs_mask, &
-                   id_dim_zu_mask, id_dim_zw_mask, &
-                   id_set_mask, &
-                   id_var_time_mask, id_var_x_mask, id_var_xu_mask, &
-                   id_var_y_mask, id_var_yv_mask, id_var_zs_mask, &
-                   id_var_zu_mask, id_var_zw_mask, &
-                   id_var_zusi_mask, id_var_zwwi_mask
-
-    INTEGER(iwp), DIMENSION(0:2,1:max_masks,0:1) ::  id_var_eutm_mask, &
-                                                     id_var_nutm_mask
-
-    INTEGER(iwp), DIMENSION(0:2,1:max_masks,0:1) ::  id_var_lat_mask, &
-                                                     id_var_lon_mask
-
-    INTEGER(iwp), DIMENSION(1:max_masks,0:1,100) ::  id_var_domask
-
     REAL(wp) ::  fill_value = -9999.0_wp    !< value for the _FillValue attribute
 
 
-    PUBLIC  dofl_dim_label_x, dofl_dim_label_y, dofl_dim_label_z, dofl_label,  &
-            dofl_time_count, dofl_unit, domask_unit, dopr_unit, dopts_num,     &
-            dots_label, dots_max, dots_num, dots_rad, dots_soil, dots_unit,    &
-            do2d_unit, do3d_unit, fill_value, id_set_agt, id_set_fl,           &
-            id_set_mask, id_set_pr, id_set_prt, id_set_pts, id_set_sp,         &
-            id_set_ts, id_set_xy, id_set_xz, id_set_yz, id_set_3d, id_var_agt, &
-            id_var_domask, id_var_dofl, id_var_dopr, id_var_dopts,             &
-            id_var_dospx, id_var_dospy, id_var_dots, id_var_do2d, id_var_do3d, &
-            id_var_norm_dopr, id_var_time_agt, id_var_time_fl,                 &
-            id_var_time_mask, id_var_time_pr, id_var_rnoa_agt, id_var_time_pts,&
-            id_var_time_sp, id_var_time_ts,                                    &
-            id_var_time_xy, id_var_time_xz, id_var_time_yz, id_var_time_3d,    &
-            id_var_x_fl, id_var_y_fl, id_var_z_fl,  nc_stat,                   &
-            netcdf_data_format, netcdf_data_format_string, netcdf_deflate,     &
-            netcdf_precision, output_for_t0, heatflux_output_unit,             &
-            waterflux_output_unit, momentumflux_output_unit
+    PUBLIC  dofl_dim_label_x, dofl_dim_label_y, dofl_dim_label_z, dofl_label, dofl_time_count,     &
+            dofl_unit, domask_unit, dopr_unit, dopts_num, dots_label, dots_max, dots_num, dots_rad,&
+            dots_soil, dots_unit, do2d_unit, do3d_unit, fill_value, id_set_agt, id_set_fl,         &
+            id_set_mask, id_set_pr, id_set_prt, id_set_pts, id_set_sp, id_set_ts, id_set_xy,       &
+            id_set_xz, id_set_yz, id_set_3d, id_var_agt, id_var_domask, id_var_dofl, id_var_dopr,  &
+            id_var_dopts, id_var_dospx, id_var_dospy, id_var_dots, id_var_do2d, id_var_do3d,       &
+            id_var_norm_dopr, id_var_time_agt, id_var_time_fl, id_var_time_mask, id_var_time_pr,   &
+            id_var_rnoa_agt, id_var_time_pts, id_var_time_sp, id_var_time_ts, id_var_time_xy,      &
+            id_var_time_xz, id_var_time_yz, id_var_time_3d, id_var_x_fl, id_var_y_fl, id_var_z_fl, &
+            nc_stat, netcdf_data_format, netcdf_data_format_string, netcdf_deflate,                &
+            netcdf_precision, output_for_t0, heatflux_output_unit, waterflux_output_unit,          &
+            momentumflux_output_unit
 
     SAVE
@@ -412,7 +400,6 @@
     END INTERFACE netcdf_open_write_file
 
-    PUBLIC netcdf_create_att, netcdf_create_dim, netcdf_create_file,           &
-           netcdf_create_global_atts, netcdf_create_var, netcdf_define_header, &
-           netcdf_handle_error, netcdf_open_write_file
+    PUBLIC netcdf_create_att, netcdf_create_dim, netcdf_create_file, netcdf_create_global_atts,    &
+           netcdf_create_var, netcdf_define_header, netcdf_handle_error, netcdf_open_write_file
 
  CONTAINS
@@ -422,89 +409,84 @@
 #if defined( __netcdf )
 
-    USE arrays_3d,                                                             &
+    USE arrays_3d,                                                                                 &
         ONLY:  zu, zw
 
-    USE biometeorology_mod,                                                    &
+    USE biometeorology_mod,                                                                        &
         ONLY:  bio_define_netcdf_grid
 
-    USE chemistry_model_mod,                                                   &
+    USE chemistry_model_mod,                                                                       &
         ONLY:  chem_define_netcdf_grid
 
-    USE basic_constants_and_equations_mod,                                     &
-        ONLY:  convert_utm_to_geographic,                                      &
+    USE basic_constants_and_equations_mod,                                                         &
+        ONLY:  convert_utm_to_geographic,                                                          &
                pi
 
-    USE control_parameters,                                                    &
-        ONLY:  agent_time_unlimited, air_chemistry, averaging_interval,        &
-               averaging_interval_pr, data_output_pr, domask, dopr_n,          &
-               dopr_time_count, dopts_time_count, dots_time_count,             &
-               do2d, do2d_at_begin, do2d_xz_time_count, do3d, do3d_at_begin,   &
-               do2d_yz_time_count, dt_data_output_av, dt_do2d_xy, dt_do2d_xz,  &
-               dt_do2d_yz, dt_do3d, dt_write_agent_data, mask_size,            &
-               do2d_xy_time_count, do3d_time_count, domask_time_count,         &
-               end_time, indoor_model, land_surface,                           &
-               mask_size_l, mask_i, mask_i_global, mask_j, mask_j_global,      &
-               mask_k_global, mask_surface,                                    &
-               message_string, ntdim_2d_xy, ntdim_2d_xz,                       &
-               ntdim_2d_yz, ntdim_3d, nz_do3d, ocean_mode, plant_canopy,       &
-               run_description_header, salsa, section, simulated_time,         &
-               simulated_time_at_begin, skip_time_data_output_av,              &
-               skip_time_do2d_xy, skip_time_do2d_xz, skip_time_do2d_yz,        &
-               skip_time_do3d, topography, num_leg, num_var_fl,                &
-               urban_surface
-
-    USE diagnostic_output_quantities_mod,                                      &
+    USE control_parameters,                                                                        &
+        ONLY:  agent_time_unlimited, air_chemistry, averaging_interval, averaging_interval_pr,     &
+               data_output_pr, domask, dopr_n, dopr_time_count, dopts_time_count, dots_time_count, &
+               do2d, do2d_at_begin, do2d_xz_time_count, do3d, do3d_at_begin, do2d_yz_time_count,   &
+               dt_data_output_av, dt_do2d_xy, dt_do2d_xz, dt_do2d_yz, dt_do3d, dt_write_agent_data,&
+               mask_size, do2d_xy_time_count, do3d_time_count, domask_time_count, end_time,        &
+               indoor_model, land_surface, mask_size_l, mask_i, mask_i_global, mask_j,             &
+               mask_j_global, mask_k_global, mask_surface, message_string, ntdim_2d_xy,            &
+               ntdim_2d_xz, ntdim_2d_yz, ntdim_3d, nz_do3d, ocean_mode, plant_canopy,              &
+               run_description_header, salsa, section, simulated_time, simulated_time_at_begin,    &
+               skip_time_data_output_av, skip_time_do2d_xy, skip_time_do2d_xz, skip_time_do2d_yz,  &
+               skip_time_do3d, topography, num_leg, num_var_fl, urban_surface
+
+    USE diagnostic_output_quantities_mod,                                                          &
         ONLY:  doq_define_netcdf_grid
 
-    USE grid_variables,                                                        &
+    USE grid_variables,                                                                            &
         ONLY:  dx, dy, zu_s_inner, zw_w_inner
 
-    USE gust_mod,                                                              &
+    USE gust_mod,                                                                                  &
         ONLY: gust_define_netcdf_grid, gust_module_enabled
 
-    USE indices,                                                               &
+    USE indices,                                                                                   &
         ONLY:  nx, nxl, nxr, ny, nys, nyn, nz ,nzb, nzt
 
     USE kinds
 
-    USE indoor_model_mod,                                                      &
+    USE indoor_model_mod,                                                                          &
         ONLY: im_define_netcdf_grid
 
-    USE land_surface_model_mod,                                                &
+    USE land_surface_model_mod,                                                                    &
         ONLY: lsm_define_netcdf_grid, nzb_soil, nzt_soil, nzs, zs
 
-    USE ocean_mod,                                                             &
+    USE ocean_mod,                                                                                 &
         ONLY:  ocean_define_netcdf_grid
 
     USE pegrid
 
-    USE particle_attributes,                                                   &
+    USE particle_attributes,                                                                       &
         ONLY:  number_of_particle_groups
 
-    USE plant_canopy_model_mod,                                                &
+    USE plant_canopy_model_mod,                                                                    &
         ONLY:  pch_index, pcm_define_netcdf_grid
 
-    USE profil_parameter,                                                      &
+    USE profil_parameter,                                                                          &
         ONLY:  crmax, cross_profiles, dopr_index, profile_columns, profile_rows
 
-    USE radiation_model_mod,                                                   &
+    USE radiation_model_mod,                                                                       &
         ONLY: radiation, radiation_define_netcdf_grid
 
-    USE salsa_mod,                                                             &
+    USE salsa_mod,                                                                                 &
         ONLY:  salsa_define_netcdf_grid
 
-    USE spectra_mod,                                                           &
-        ONLY:  averaging_interval_sp, comp_spectra_level, data_output_sp, dosp_time_count, spectra_direction
-
-    USE statistics,                                                            &
+    USE spectra_mod,                                                                               &
+        ONLY:  averaging_interval_sp, comp_spectra_level, data_output_sp, dosp_time_count,         &
+               spectra_direction
+
+    USE statistics,                                                                                &
         ONLY:  hom, statistic_regions
 
-    USE turbulence_closure_mod,                                                &
+    USE turbulence_closure_mod,                                                                    &
         ONLY:  tcm_define_netcdf_grid
 
-    USE urban_surface_mod,                                                     &
+    USE urban_surface_mod,                                                                         &
         ONLY:  usm_define_netcdf_grid
 
-    USE user,                                                                  &
+    USE user,                                                                                      &
         ONLY:  user_module_enabled, user_define_netcdf_grid
 
@@ -513,16 +495,16 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=3)              ::  suffix                !<
     CHARACTER (LEN=2), INTENT (IN) ::  callmode              !<
+    CHARACTER (LEN=4000)           ::  char_cross_profiles   !<
     CHARACTER (LEN=4)              ::  grid_x                !<
     CHARACTER (LEN=4)              ::  grid_y                !<
     CHARACTER (LEN=4)              ::  grid_z                !<
     CHARACTER (LEN=6)              ::  mode                  !<
+    CHARACTER (LEN=20)             ::  netcdf_var_name       !<
     CHARACTER (LEN=10)             ::  precision             !<
+    CHARACTER (LEN=3)              ::  suffix                !<
+    CHARACTER (LEN=80)             ::  time_average_text     !<
+    CHARACTER (LEN=varnamelength)  ::  trimvar               !< TRIM of output-variable string
     CHARACTER (LEN=10)             ::  var                   !<
-    CHARACTER (LEN=20)             ::  netcdf_var_name       !<
-    CHARACTER (LEN=varnamelength)  ::  trimvar               !< TRIM of output-variable string
-    CHARACTER (LEN=80)             ::  time_average_text     !<
-    CHARACTER (LEN=4000)           ::  char_cross_profiles   !<
     CHARACTER (LEN=4000)           ::  var_list              !<
     CHARACTER (LEN=4000)           ::  var_list_old          !<
@@ -545,4 +527,5 @@
     INTEGER(iwp) ::  k                                       !<
     INTEGER(iwp) ::  kk                                      !<
+    INTEGER(iwp) ::  l                                       !<
     INTEGER(iwp) ::  mid                                     !< masked output running index
     INTEGER(iwp) ::  ns                                      !<
@@ -551,5 +534,4 @@
     INTEGER(iwp) ::  ntime_count                             !< number of time levels found in file
     INTEGER(iwp) ::  nz_old                                  !<
-    INTEGER(iwp) ::  l                                       !<
 
     INTEGER(iwp), SAVE ::  oldmode                           !<
@@ -566,7 +548,6 @@
     INTEGER(iwp), DIMENSION(1:crmax) ::  cross_profiles_numb !<
 
-    LOGICAL ::  found                                        !<
-
     LOGICAL, INTENT (INOUT) ::  extend                       !<
+    LOGICAL                 ::  found                        !<
 
     LOGICAL, SAVE ::  init_netcdf = .FALSE.                  !<
@@ -591,5 +572,5 @@
     IF ( .NOT. init_netcdf )  THEN
 !
-!--    Check and set accuracy for netCDF output. First set default value
+!--    Check and set accuracy for netCDF output. First set default value.
        nc_precision = NF90_REAL4
 
@@ -598,6 +579,6 @@
           j = INDEX( netcdf_precision(i), '_' )
           IF ( j == 0 )  THEN
-             WRITE ( message_string, * ) 'netcdf_precision must contain a ', &
-                                         '"_"netcdf_precision(', i, ')="',   &
+             WRITE ( message_string, * ) 'netcdf_precision must contain a ',                       &
+                                         '"_"netcdf_precision(', i, ')="',                         &
                                          TRIM( netcdf_precision(i) ),'"'
              CALL message( 'netcdf_define_header', 'PA0241', 2, 2, 0, 6, 0 )
@@ -612,6 +593,6 @@
              j = NF90_REAL8
           ELSE
-             WRITE ( message_string, * ) 'illegal netcdf precision: ',  &
-                                         'netcdf_precision(', i, ')="', &
+             WRITE ( message_string, * ) 'illegal netcdf precision: ',                             &
+                                         'netcdf_precision(', i, ')="',                            &
                                          TRIM( netcdf_precision(i) ),'"'
              CALL message( 'netcdf_define_header', 'PA0242', 1, 2, 0, 6, 0 )
@@ -645,7 +626,6 @@
 
              CASE DEFAULT
-                WRITE ( message_string, * ) 'unknown variable in ' //          &
-                                  'initialization_parameters ',                &
-                                  'assignment: netcdf_precision(', i, ')="',   &
+                WRITE ( message_string, * ) 'unknown variable in ' // 'initialization_parameters ',&
+                                            'assignment: netcdf_precision(', i, ')="',             &
                                             TRIM( netcdf_precision(i) ),'"'
                 CALL message( 'netcdf_define_header', 'PA0243', 1, 2, 0, 6, 0 )
@@ -660,7 +640,6 @@
 !--    Check for allowed parameter range
        IF ( netcdf_deflate < 0  .OR.  netcdf_deflate > 9 )  THEN
-          WRITE ( message_string, '(A,I3,A)' ) 'netcdf_deflate out of ' //     &
-                                      'range & given value: ', netcdf_deflate, &
-                                      ', allowed range: 0-9'
+          WRITE ( message_string, '(A,I3,A)' ) 'netcdf_deflate out of ' // 'range & given value: ',&
+                                               netcdf_deflate, ', allowed range: 0-9'
           CALL message( 'netcdf_define_header', 'PA0355', 2, 2, 0, 6, 0 )
        ENDIF
@@ -687,7 +666,6 @@
 
 !
-!-- Select the mode to be processed. Possibilities are 3d, ma (mask), xy, xz,
-!-- yz, pr (profiles), ps (particle timeseries), fl (flight data), ts
-!-- (timeseries) or sp (spectra)
+!-- Select the mode to be processed. Possibilities are 3d, ma (mask), xy, xz, yz, pr (profiles), ps
+!-- (particle timeseries), fl (flight data), ts (timeseries) or sp (spectra).
     SELECT CASE ( mode )
 
@@ -695,6 +673,5 @@
 
 !
-!--       decompose actual parameter file_id (=formal parameter av) into
-!--       mid and av
+!--       Decompose actual parameter file_id (=formal parameter av) into mid and av
           file_id = av
           IF ( file_id <= 200+max_masks )  THEN
@@ -709,10 +686,12 @@
 !--       Define some global attributes of the dataset
           IF ( av == 0 )  THEN
-             CALL netcdf_create_global_atts( id_set_mask(mid,av), 'podsmasked', TRIM( run_description_header ), 464 )
+             CALL netcdf_create_global_atts( id_set_mask(mid,av), 'podsmasked',                    &
+                                             TRIM( run_description_header ), 464 )
              time_average_text = ' '
           ELSE
-             CALL netcdf_create_global_atts( id_set_mask(mid,av), 'podsmasked', TRIM( run_description_header ), 464 )
+             CALL netcdf_create_global_atts( id_set_mask(mid,av), 'podsmasked',                    &
+                                             TRIM( run_description_header ), 464 )
              WRITE ( time_average_text,'(F7.1,'' s avg'')' )  averaging_interval
-             nc_stat = NF90_PUT_ATT( id_set_mask(mid,av), NF90_GLOBAL, 'time_avg',   &
+             nc_stat = NF90_PUT_ATT( id_set_mask(mid,av), NF90_GLOBAL, 'time_avg',                 &
                                      TRIM( time_average_text ) )
              CALL netcdf_handle_error( 'netcdf_define_header', 466 )
@@ -721,11 +700,12 @@
 !
 !--       Define time coordinate for volume data (unlimited dimension)
-          CALL netcdf_create_dim( id_set_mask(mid,av), 'time', NF90_UNLIMITED, &
+          CALL netcdf_create_dim( id_set_mask(mid,av), 'time', NF90_UNLIMITED,                     &
                                   id_dim_time_mask(mid,av), 467 )
-          CALL netcdf_create_var( id_set_mask(mid,av),                         &
-                                  (/ id_dim_time_mask(mid,av) /), 'time',      &
-                                  NF90_DOUBLE, id_var_time_mask(mid,av),       &
+          CALL netcdf_create_var( id_set_mask(mid,av),                                             &
+                                  (/ id_dim_time_mask(mid,av) /), 'time',                          &
+                                  NF90_DOUBLE, id_var_time_mask(mid,av),                           &
                                  'seconds', 'time', 468, 469, 000 )
-          CALL netcdf_create_att( id_set_mask(mid,av), id_var_time_mask(mid,av), 'standard_name', 'time', 000)
+          CALL netcdf_create_att( id_set_mask(mid,av), id_var_time_mask(mid,av),                   &
+                                  'standard_name', 'time', 000)
           CALL netcdf_create_att( id_set_mask(mid,av), id_var_time_mask(mid,av), 'axis', 'T', 000)
 
